unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, Math, StdCtrls, Grids, Menus, ExtCtrls;

type
  TA = Array [1..26] of String;

  TForm1 = class(TForm)
    Button1: TButton;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Edit1: TEdit;
    Edit2: TEdit;
    Edit3: TEdit;
    Edit5: TEdit;
    ListBox1: TListBox;
    StringGrid1: TStringGrid;
    MainMenu1: TMainMenu;
    N1: TMenuItem;
    N2: TMenuItem;
    N3: TMenuItem;
    N4: TMenuItem;
    N5: TMenuItem;
    Label7: TLabel;
    Label8: TLabel;
    Label10: TLabel;
    Edit9: TEdit;
    Label11: TLabel;
    Memo1: TMemo;
    ListBox2: TListBox;
    N6: TMenuItem;
    N7: TMenuItem;
    OpenDialog1: TOpenDialog;
    SaveDialog1: TSaveDialog;
    N8: TMenuItem;
    N351: TMenuItem;
    N9: TMenuItem;
    procedure Button1Click(Sender: TObject);
    procedure OnN4(Sender: TObject);
    procedure OnN5(Sender: TObject);
    procedure N7Click(Sender: TObject);
    procedure N9Click(Sender: TObject);
  private
    function AddVN(P, S: String): String;
    function CheckDFA: Boolean;
    function CheckState(S: String): Boolean;
    procedure DeleteUnavailables;
    function NewAVN: String;
    procedure NFAToDFA;
    procedure OutAutomat;
    function RLAuto: Boolean;
    function ReadGrammar: Boolean;
    procedure RenameVN;
    function RGToNFA: Boolean;
    function SortString(S: String): String;
  public
    { Public declarations }
  end;

var
 Form1: TForm1;
 P: Array [1..26,1..10] of String;
 VN: TA;
 Final: Array [1..26] of Boolean;
 AVN, S0, SF, SVN, SVT, SEmpty: String;
 NVN: Integer;

implementation

{$R *.dfm}

function TForm1.AddVN(P, S: String): String;
var I: Integer;
begin
 for I:=1 to Length(S) do
  if Pos(S[I],P)=0 then P:=P+S[I];
 AddVN:=SortString(P);
end;

function TForm1.CheckDFA: Boolean;
var I, J: Integer;
begin
 for I:=1 to NVN do
  for J:=1 to Length(SVT) do
   if Length(P[I,J])>1 then begin
    CheckDFA:=FALSE;
    exit;
   end;
 CheckDFA:=TRUE;
end;

function TForm1.CheckState(S: String): Boolean;
var I: Integer;
begin
 for I:=1 to NVN do
  if S=VN[I] then begin
   CheckState:=TRUE;
   exit;
  end;
 CheckState:=FALSE;
end;

procedure TForm1.DeleteUnavailables;
var I, J, K, N1, N2: Integer; S1, S2: Array [1..26] of String;

function PosVN(V: String; VN: Array of String; N: Integer): Integer;
var I: Integer;
begin
 for I:=0 to N-1 do
  if V=VN[I] then begin
   Result:=I+1;
   exit;
  end;
 Result:=0;
end;

begin
 N1:=1;
 N2:=1;
 S1[N1]:=S0;
 S2[N2]:=S0;
 while TRUE do begin
  for I:=1 to N1 do begin
   J:=PosVN(S1[I],VN,NVN);
   for K:=1 to Length(SVT) do
    if (P[J,K]<>'') And (PosVN(P[J,K],S2,N2)=0) then begin
     Inc(N2);
     S2[N2]:=P[J,K];
    end;
  end;
  if N1=N2 then break;
  N1:=N2;
  for I:=1 to N2 do S1[I]:=S2[I];
 end;
 I:=1;
 while (I<=NVN) do
  if PosVN(VN[I],S1,N1)=0 then begin
   Dec(NVN);
   Delete(SVN,I,1);
   for J:=I to NVN do begin
    Final[J]:=Final[J+1];
    VN[J]:=VN[J+1];
    for K:=1 to Length(SVT) do P[J,K]:=P[J+1,K];
   end;
  end
  else
   Inc(I);
end;

function TForm1.NewAVN: String;
var I: Integer; S: String;
begin
 S:='A';
 for I:=1 to 25 do
  if Pos(S[1],AVN)=0 then begin
   AVN:=AVN+S;
   Result:=S;
   exit;
  end
  else
   Inc(S[1]);
 ShowMessage('  26      ');
 Result:='';
end;

procedure TForm1.NFAToDFA;
var I, J, K, L: Integer; FDo: Boolean;
begin
 FDo:=TRUE;
 while (FDo) do begin
  FDo:=FALSE;
  I:=1;
  while ((Not FDo) And (I<=NVN)) do begin
   J:=1;
   while ((Not FDo) And (J<=Length(SVT))) do
    if ((P[I,J]<>'') And (Not CheckState(P[I,J]))) then FDo:=TRUE
                                                   else Inc(J);
   if Not FDo then Inc(I);
  end;
  if FDo then begin
   Inc(NVN);
   VN[NVN]:=P[I,J];
   for I:=1 to Length(VN[NVN]) do begin
    L:=Pos(VN[NVN][I],SVN);
    Final[NVN]:=Final[NVN] Or Final[L];
    for K:=1 to Length(SVT) do
     if P[L,K]<>'' then P[NVN,K]:=AddVN(P[NVN,K],P[L,K]);
   end;
  end;
 end;
end;

procedure TForm1.OutAutomat;
var I, J: Integer; S: String;
begin
 SF:='';
 StringGrid1.ColCount:=Length(SVT)+1;
 StringGrid1.RowCount:=NVN+1;
 for J:=1 to Length(SVT) do StringGrid1.Cells[J,0]:=SVT[J];
 for I:=1 to NVN do begin
  StringGrid1.Cells[0,I]:=VN[I];
  for J:=1 to Length(SVT) do StringGrid1.Cells[J,I]:=P[I,J];
  if Final[I] then SF:=SF+VN[I];
 end;
 S:='M({'+VN[1];
 for I:=2 to NVN do S:=S+','+VN[I];
 S:=S+'},{'+SVT[1];
 for I:=2 to Length(SVT) do S:=S+','+SVT[I];
 S:=S+'},f,'+S0+',{'+SF[1];
 for I:=2 to Length(SF) do S:=S+','+SF[I];
 Label4.Caption:=S+'})';
end;

function TForm1.RLAuto: Boolean;
var I, J: Integer; S, V, VNew: String;
begin
 AVN:=SVN;
 ListBox2.Items.Clear;
 for I:=0 to Memo1.Lines.Count-1 do begin
  S:=Memo1.Lines[I];
  if S='' then continue;
  Delete(S,1,2);
  if (Length(S)=1) And (Pos(S[1],SVN)>0) then begin
   ShowMessage('  <'+Memo1.Lines[I]+'>');
   Result:=false;
   exit;
  end;
  for J:=1 to Length(S) do
   if (S[J]=SEmpty) And (Length(S)>1) then begin
    ShowMessage('          <'+Memo1.Lines[I]+'>');
    Result:=false;
    exit;
   end;
  V:=Memo1.Lines[I][1];
  while Length(S)>2 do begin
   VNew:=NewAVN;
   if VNew='' then begin
    Result:=false;
    exit;
   end;
   ListBox2.Items.Add(V+'='+S[1]+VNew);
   Delete(S,1,1);
   V:=VNew;
  end;
  if (Length(S)>1) And (Pos(S[2],SVT)>0) then begin
   VNew:=NewAVN;
   if VNew='' then begin
    Result:=false;
    exit;
   end;
   ListBox2.Items.Add(V+'='+S[1]+VNew);
   ListBox2.Items.Add(VNew+'='+S[2]);
  end
  else
   ListBox2.Items.Add(V+'='+S);
 end;
 Result:=true;
end;

function TForm1.ReadGrammar: Boolean;
var I, J: Integer; S: String;
begin
 for I:=1 to 26 do begin
  Final[I]:=false;
  VN[I]:='';
  for J:=1 to 10 do P[I,J]:='';
 end;
 SVN:=Edit1.Text;
 NVN:=Length(SVN);
 SVT:=Edit2.Text;
 S0:=Edit3.Text;
 SEmpty:=Edit9.Text;
 if SEmpty='' then begin
  ShowMessage('   ');
  ReadGrammar:=false;
  exit;
 end;
 if Pos(SEmpty,SVN)<>0 then begin
  ShowMessage('     ');
  ReadGrammar:=false;
  exit;
 end;
 if Pos(SEmpty,SVT)<>0 then begin
  ShowMessage('     ');
  ReadGrammar:=false;
  exit;
 end;
 if SVN='' then begin
  ShowMessage('    ');
  ReadGrammar:=false;
  exit;
 end;
 if SVT='' then begin
  ShowMessage('    ');
  ReadGrammar:=false;
  exit;
 end;
 if Pos(S0,SVN)=0 then begin
  ShowMessage('    ');
  ReadGrammar:=false;
  exit;
 end;
 for I:=1 to Length(SVN)-1 do
  if Pos(SVN[I],Copy(SVN,I+1,Length(SVN)))<>0 then begin
  ShowMessage('   ');
  ReadGrammar:=false;
  exit;
 end;
 for I:=1 to Length(SVT)-1 do
  if Pos(SVT[I],Copy(SVT,I+1,Length(SVT)))<>0 then begin
  ShowMessage('   ');
  ReadGrammar:=false;
  exit;
 end;
 for I:=1 to Length(SVN) do
  if Pos(SVN[I],SVT)<>0 then begin
  ShowMessage('     ');
  ReadGrammar:=false;
  exit;
 end;
 for I:=1 to NVN do VN[I]:=SVN[I];
 for I:=0 to Memo1.Lines.Count-1 do begin
  S:=Memo1.Lines[I];
  if S='' then continue;
  if Pos(S[1],SVN)=0 then begin
   ShowMessage('  <'+S[1]+'>  ');
   ReadGrammar:=false;
   exit;
  end;
  if (Length(S)<2) Or (S[2]<>'=') then begin
   ShowMessage('  =   ');
   ReadGrammar:=false;
   exit;
  end;
  if Length(S)<3 then begin
   ShowMessage('    ');
   ReadGrammar:=false;
   exit;
  end;
  for J:=3 to Length(S) do begin
   if (S[J]<>SEmpty) And (Pos(S[J],SVT)=0) And (Pos(S[J],SVN)=0) then begin
    ShowMessage('    <'+S[J]+'>');
    ReadGrammar:=false;
    exit;
   end;
   if (Pos(S[J],SVN)>0) And (J<>Length(S)) then begin
    ShowMessage('   - <'+S+'>');
    ReadGrammar:=false;
    exit;
   end;
  end;
 end;
 ReadGrammar:=true;
end;

procedure TForm1.RenameVN;
var NT: String; I, J, K, L: Integer;
begin
 NT:='A';
 for I:=1 to NVN do
  if Length(VN[I])>1 then begin
   J:=1;
   while J<=NVN do
    if NT=VN[J] then begin
     J:=1;
     NT:=Chr(Ord(NT[1])+1);
    end
    else
     Inc(J);
   for K:=1 to 26 do
    for L:=1 to 10 do
     if P[K,L]=VN[I] then P[K,L]:=NT;
   VN[I]:=NT;
   NT:=Chr(Ord(NT[1])+1);
  end;
end;

function TForm1.RGToNFA: Boolean;
var I, J, N: Integer; F, S: String;
begin
 F:='';
 for I:=0 to ListBox2.Items.Count-1 do begin
  S:=ListBox2.Items[I];
  N:=Pos(S[1],AVN);
  J:=Pos(S[3],SVT);
  if Length(S)=3 then
   if S[3]=SEmpty then Final[N]:=true
   else begin
    if F='' then begin
     F:=NewAVN;
     Final[Length(AVN)]:=true;
     if F='' then begin
      Result:=false;
      exit;
     end;
    end;
    P[N,J]:=P[N,J]+F;
   end
  else
   P[N,J]:=P[N,J]+S[4];
 end;
 SVN:=AVN;
 NVN:=Length(AVN);
 for I:=1 to NVN do VN[I]:=AVN[I];
 Result:=true;
end;

function TForm1.SortString(S: String): String;
var I, J: Integer; Ch: Char;
begin
 for I:=1 to Length(S)-1 do
  for J:=I+1 to Length(S) do
   if (((S[I]>S[J]) And (S[I]<>S0[1])) Or (S[J]=S0[1])) then begin
    Ch:=S[J];
    S[J]:=S[I];
    S[I]:=Ch;
   end;
 SortString:=S;
end;

procedure TForm1.OnN4(Sender: TObject);
begin
 if Not ReadGrammar then exit;
 if Not RLAuto then exit;
 if Not RGToNFA then exit;
 OutAutomat;
 Button1.Enabled:=FALSE;
end;

procedure TForm1.OnN5(Sender: TObject);
begin
 if Not ReadGrammar then exit;
 if Not RLAuto then exit;
 if Not RGToNFA then exit;
 OutAutomat;
 if Not CheckDFA then begin
  NFAToDFA;
  DeleteUnavailables;
  OutAutomat;
 end;
 RenameVN;
 OutAutomat;
 Button1.Enabled:=TRUE;
end;

procedure TForm1.Button1Click(Sender: TObject);
var I, J: Integer; AVN, SW:String;
begin
 ListBox1.Items.Clear;
 AVN:='';
 for I:=1 to NVN do AVN:=AVN+VN[I];
 SW:=Edit5.Text;
 I:=Pos(S0,AVN);
 while (SW<>'') do begin
  ListBox1.Items.Add('('+AVN[I]+','+SW+')');
  J:=Pos(SW[1],SVT);
  if J=0 then begin
   ListBox1.Items.Add('   ');
   exit;
  end;
  if P[I,J]='' then begin
   ListBox1.Items.Add('   '+AVN[I]+'   '+SW[1]+'');
   exit;
  end;
  I:=Pos(P[I,J],AVN);
  Delete(SW,1,1);
 end;
 ListBox1.Items.Add('('+AVN[I]+','+SEmpty+')');
 if Pos(AVN[I],SF)=0 then
  ListBox1.Items.Add('    ')
 else
  ListBox1.Items.Add(' ');
end;

procedure TForm1.N7Click(Sender: TObject);
var I, J: Integer; S: String;
begin
 GetDir(0,S);
 SaveDialog1.InitialDir:=S;
 if Not SaveDialog1.Execute then exit;
 ListBox2.Items.Clear;
 ListBox2.Items.Add(Edit1.Text);
 ListBox2.Items.Add(Edit2.Text);
 ListBox2.Items.Add(Edit3.Text);
 for I:=0 to Memo1.Lines.Count-1 do ListBox2.Items.Add(Memo1.Lines[I]);
 ListBox2.Items.Add(Label4.Caption);
 for I:=0 to StringGrid1.RowCount-1 do with StringGrid1 do begin
  S:='';
  for J:=0 to ColCount-1 do S:=S+Cells[J,I]+Chr(9);
  ListBox2.Items.Add(S);
 end;
 for I:=0 to ListBox1.Items.Count-1 do
  ListBox2.Items.Add(ListBox1.Items.Strings[I]);
 ListBox2.Items.SaveToFile(SaveDialog1.FileName);
end;

procedure TForm1.N9Click(Sender: TObject);
var I: Integer; S: String;
begin
 GetDir(0,S);
 OpenDialog1.InitialDir:=S;
 if Not OpenDialog1.Execute then exit;
 ListBox2.Items.LoadFromFile(OpenDialog1.FileName);
 if ListBox2.Items.Count<4 then begin
  ShowMessage('    -');
  exit;
 end;
 Memo1.Lines.Clear;
 Edit1.Text:=Copy(ListBox2.Items[0],1,Edit1.MaxLength);
 Edit2.Text:=Copy(ListBox2.Items[1],1,Edit2.MaxLength);
 Edit3.Text:=Copy(ListBox2.Items[2],1,Edit3.MaxLength);
 for I:=3 to ListBox2.Items.Count-1 do
  Memo1.Lines.Add(ListBox2.Items.Strings[I]);
end;

end.
